#include <avr/io.h>
#include <avr/pgmspace.h>

typedef unsigned char byte;
#define elemof(x) (sizeof(x)/sizeof(*(x)))

namespace hd44780{

constexpr byte tr00(wchar_t wc) {
 const wchar_t katakana[] =
 L"　。「」、・ヲァィゥェォャュョッ"
 L"ーアイウエオカキクケコサシスセソ"
 L"タチツテトナニヌネノハヒフヘホマ"
 L"ミムメモヤユヨラリルレロワン゛゜";
 for (byte i=0; i<64; i++) if (katakana[i]==wc) return 160+i;
 const wchar_t extra[] =
 L"αäβεμσρg√¹j‾¢£ñö"
 L"pqθ∞ΩüΣπⓧy千万円÷ █";
 for (byte i=0; i<32; i++) if (extra[i]==wc) return 224+i;
 switch (wc) {
  case L'¥': return  92;
  case L'→': return 126;
  case L'←': return 127;
  case L'°': return 223;
  case L'ß': return 225;
  case L'Ω': return 244;
 }
 const wchar_t graf[] =
 L"\\~ÄÜ";
 for (byte i=0; i<elemof(graf)-1; i++) if (graf[i]==wc) return 16+i;
 return byte(wc);
}

template<size_t N>struct str00{
 byte a[N] {};
 constexpr str00(const wchar_t ini[N]) {
  for (size_t i=0; i<N; i++) a[i]=tr00(ini[i]);
 }
 operator const byte*() const {return a+0x8000;}
};

}

#define A00(s) hd44780::str00<elemof(L##s)>(L##s)
#define F00(s) __extension__({static const PROGMEM hd44780::str00<elemof(L##s)> c(L##s); c.a+0x8000;})

const auto PROGMEM str1 = A00("tränenüberströmt");

__attribute__((OS_main)) int main() {
 pgm_read_byte(&str1);
 pgm_read_byte(F00("maßlos überfördärt °C"));
 for(;;);
}
